--- Portfile.orig	2018-01-30 17:59:31.000000000 -0600
+++ Portfile	2018-01-30 19:30:35.000000000 -0600
@@ -1,6 +1,6 @@
 PortSystem 1.0
 name		geoexpress-sdk
-version		9.0.0.3864
+version		9.5.4.4709
 maintainers	nomaintainer
 platforms	darwin
 description	LizardTech's SDK for reading MrSID and JPEG 2000 imagery
@@ -14,11 +14,11 @@
 master_sites	http://www.lizardtech.com/developer/
 categories	science
 
-distname	MrSID_DSDK-${version}-darwin12.universal.gccA42
-worksrcdir	MrSID_DSDK-${version}-darwin12.universal.gccA42
+distname	MrSID_DSDK-${version}-darwin16.universal.clang80
+worksrcdir	MrSID_DSDK-${version}-darwin16.universal.clang80
 
-checksums       rmd160	8dfa4c95cd5f238b88e5629da097462a4fc77407 \
-                sha256 e8918b08571d7669cf44b363494de9767f61375f323bb6aab83069bd13d1f9bd
+checksums           rmd160  1afa1c4bf109712cfbc436c20431cf102ca7a175 \
+                    sha256  086f5dd508484e7ad915fb76ab962e96099b37ca8d759a0112d51eaa007cb488
 
 fetch {
 	file mkdir ${distpath}
@@ -35,25 +35,32 @@
 	system "ln -s ${prefix}/share/Geo_DSDK/Raster_DSDK/bin/mrsiddecode ${destroot}${prefix}/bin/mrsiddecode"
 	system "ln -s ${prefix}/share/Geo_DSDK/Raster_DSDK/bin/mrsidinfo ${destroot}${prefix}/bin/mrsidinfo"
         
-        system "install_name_tool -change /data/builds/Bob/darwin12.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos_c.1.dylib  ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/bin/mrsiddecode"
+#        system "install_name_tool -change /data/builds/Bob/darwin16.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos_c.1.dylib  ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/bin/mrsiddecode"
 
         system "install_name_tool -change libtbb.dylib  ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libtbb.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/bin/mrsiddecode"
 
-        system "install_name_tool -change /data/builds/Bob/darwin12.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos_c.1.dylib ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.1.1.dylib"
+#        system "install_name_tool -change /data/builds/Bob/darwin16.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos_c.1.dylib ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.dylib /opt/local/lib/libgeos_c.1.dylib"
 
-        system "install_name_tool -change /data/builds/Bob/darwin12.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos.2.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.1.1.dylib"
+#        system "install_name_tool -change /data/builds/Bob/darwin16.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos.2.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.1.1.dylib"
 
-        system "install_name_tool -change /data/builds/Bob/darwin12.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos_c.1.dylib  ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/bin/mrsidinfo"
+#        system "install_name_tool -change /data/builds/Bob/darwin16.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos_c.1.dylib  ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/bin/mrsidinfo"
 
         system "install_name_tool -change libtbb.dylib  ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libtbb.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/bin/mrsidinfo"
 
         system "install_name_tool -change libtbb.dylib  ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libtbb.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libltidsdk.9.dylib"
 
-        system "install_name_tool -change /data/builds/Bob/darwin12.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos.2.dylib ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos.2.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.1.1.dylib"
+#        system "install_name_tool -change /data/builds/Bob/darwin16.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos.2.dylib ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos.2.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.1.1.dylib"
 
-        system "install_name_tool -change /data/builds/Bob/darwin12.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos.2.dylib ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos.2.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.dylib"
+#        system "install_name_tool -change /data/builds/Bob/darwin16.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos.2.dylib ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos.2.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.1.dylib"
 
         system "install_name_tool -change libtbb.dylib  ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libtbb.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libltidsdk.dylib"
 
-        system "install_name_tool -change /data/builds/Bob/darwin12.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos.2.dylib ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos.2.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.dylib"
+#        system "install_name_tool -change /data/builds/Bob/darwin16.universal.gccA42__default/xt_lib_geos/darwin12.universal.gccA42/Release/src/geos-2.2.3/../../../../dist/darwin12.universal.gccA42/Release/lib/libgeos.2.dylib ${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos.2.dylib ${destroot}${prefix}/share/Geo_DSDK/Raster_DSDK/lib/libgeos_c.dylib"
+	
+	system "install_name_tool -add_rpath "/opt/local/share/Geo_DSDK/Raster_DSDK/lib/" /opt/local/share/Geo_DSDK/Raster_DSDK/lib/libtbb.dylib"
+
+	system "install_name_tool -add_rpath "/opt/local/share/Geo_DSDK/Raster_DSDK/lib/" /opt/local/share/Geo_DSDK/Raster_DSDK/lib/libltidsdk.dylib"
+
+	system "install_name_tool -add_rpath "/opt/local/share/Geo_DSDK/Raster_DSDK/lib/" /opt/local/lib/libgdal.20.dylib"
+
 }